diff --git a/ChangeLog.d/feature/ZBXNEXT-6401 b/ChangeLog.d/feature/ZBXNEXT-6401
new file mode 100644
index 00000000000..bc2475154d2
--- /dev/null
+++ b/ChangeLog.d/feature/ZBXNEXT-6401
@@ -0,0 +1 @@
+.......PS. [ZBXNEXT-6401] added new vmware keys vmware.datastore.perfcounter and vmware.hv.diskinfo.get (MVekslers)
diff --git a/include/common.h b/include/common.h
index 917a7bbefc3..2d2610c5569 100644
--- a/include/common.h
+++ b/include/common.h
@@ -1315,6 +1315,7 @@ zbx_uint64_t	iprange_volume(const zbx_iprange_t *iprange);
 char	*zbx_age2str(int age);
 char	*zbx_date2str(time_t date, const char *tz);
 char	*zbx_time2str(time_t time, const char *tz);
+int	zbx_iso8601_utc(const char *str, time_t *time);
 
 #define ZBX_NULL2STR(str)	(NULL != str ? str : "(null)")
 #define ZBX_NULL2EMPTY_STR(str)	(NULL != (str) ? (str) : "")
diff --git a/include/zbxxml.h b/include/zbxxml.h
index 378973b919a..8a7217239ba 100644
--- a/include/zbxxml.h
+++ b/include/zbxxml.h
@@ -50,6 +50,7 @@ int	zbx_xml_node_read_values(xmlDoc *xdoc, xmlNode *node, const char *xpath, zbx
 int	zbx_xml_try_read_value(const char *data, size_t len, const char *xpath, xmlDoc **xdoc, char **value,
 		char **error);
 int	zbx_xml_doc_read_num(xmlDoc *xdoc, const char *xpath, int *num);
+int	zbx_xml_node_read_num(xmlDoc *xdoc, xmlNode *node, const char *xpath, int *num);
 char	*zbx_xml_node_read_value(xmlDoc *xdoc, xmlNode *node, const char *xpath);
 char	*zbx_xml_doc_read_value(xmlDoc *xdoc, const char *xpath);
 xmlNode	*zbx_xml_node_get(xmlDoc *xdoc, xmlNode *node, const char *xpath);
diff --git a/src/libs/zbxcommon/str.c b/src/libs/zbxcommon/str.c
index c3064662055..6526be2c8d6 100644
--- a/src/libs/zbxcommon/str.c
+++ b/src/libs/zbxcommon/str.c
@@ -5915,3 +5915,141 @@ void	zbx_rtrim_utf8(char *str, const char *charlist)
 
 	*last = '\0';
 }
+
+/******************************************************************************
+ *                                                                            *
+ * Purpose: convert string from iso8601 timezone info to offset in seconds    *
+ *                                                                            *
+ * Parameters: zone    - [IN] iso8601 timezone string                         *
+ *             offset  - [OUT] offset value                                   *
+ *                                                                            *
+ * Return value: SUCCEED   - the operation has completed successfully         *
+ *               FAIL      - the operation has failed                         *
+ *                                                                            *
+ ******************************************************************************/
+static int zbx_iso8601_timezone(const char *zone, long int *offset)
+{
+	int		m, h, sign = 0;
+	char		c;
+	const char	*ptr = zone;
+
+	if ('.' == *zone)	/* skip milliseconds */
+	{
+		for (ptr++; 0 != isdigit(*ptr); ptr++)
+			;
+	}
+
+	for (; ' ' == *ptr; ptr++)
+		;
+
+	*offset = 0;
+	c = *ptr;
+
+	if ('\0' == c || 'Z' == c || 'z' == c)
+		return SUCCEED;
+	else if ('-' == c)
+		sign = -1;
+	else if ('+' == c)
+		sign = +1;
+	else
+		return FAIL;
+
+	ptr++;
+
+	if (ZBX_CONST_STRLEN("00:00") > strlen(ptr) || ':' != ptr[2])
+		return FAIL;
+
+	if (0 == isdigit(*ptr) || 23 < (h = atoi(ptr)))
+		return FAIL;
+
+	if (0 == isdigit(ptr[3]) || 59 < (m = atoi(&ptr[3])))
+		return FAIL;
+
+	*offset = sign * (m + h * 60) * 60;
+
+	return SUCCEED;
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Purpose: parse string from iso8601 datetime (xml base) to UTC              *
+ *          without millisecond, supported formats:                           *
+ *              yyyy-mm-ddThh:mm:ss                                          *
+ *              yyyy-mm-ddThh:mm:ssZ                                          *
+ *              yyyy-mm-ddThh:mm:ss+hh:mm                                     *
+ *              yyyy-mm-ddThh:mm:ss-hh:mm                                     *
+ *              yyyy-mm-ddThh:mm:ss +hh:mm                                    *
+ *              yyyy-mm-ddThh:mm:ss -hh:mm                                    *
+ *              yyyy-mm-ddThh:mm:ss.ccc                                       *
+ *              yyyy-mm-ddThh:mm:ss.cccZ                                      *
+ *              yyyy-mm-ddThh:mm:ss.ccc+hh:mm                                 *
+ *              yyyy-mm-ddThh:mm:ss.ccc-hh:mm                                 *
+ *              yyyy-mm-ddThh:mm:ss.ccc +hh:mm                                *
+ *              yyyy-mm-ddThh:mm:ss.ccc -hh:mm                                *
+ *              yyyy-mm-dd hh:mm:ss                                          *
+ *              yyyy-mm-dd hh:mm:ssZ                                          *
+ *              yyyy-mm-dd hh:mm:ss+hh:mm                                     *
+ *              yyyy-mm-dd hh:mm:ss-hh:mm                                     *
+ *              yyyy-mm-dd hh:mm:ss +hh:mm                                    *
+ *              yyyy-mm-dd hh:mm:ss -hh:mm                                    *
+ *              yyyy-mm-dd hh:mm:ss.ccc                                       *
+ *              yyyy-mm-dd hh:mm:ss.cccZ                                      *
+ *              yyyy-mm-dd hh:mm:ss.ccc+hh:mm                                 *
+ *              yyyy-mm-dd hh:mm:ss.ccc-hh:mm                                 *
+ *              yyyy-mm-dd hh:mm:ss.ccc +hh:mm                                *
+ *              yyyy-mm-dd hh:mm:ss.ccc -hh:mm                                *
+ *                                                                            *
+ * Parameters: str  - [IN] iso8601 datetime string                            *
+ *             time - [OUT] parsed tm value                                   *
+ *                                                                            *
+ * Return value: SUCCEED   - the operation has completed successfully         *
+ *               FAIL      - the operation has failed                         *
+ *                                                                            *
+ ******************************************************************************/
+int	zbx_iso8601_utc(const char *str, time_t *time)
+{
+	struct tm	tm;
+
+	if ( 0 == isdigit(*str) || ZBX_CONST_STRLEN("1234-12-12T12:12:12") > strlen(str) ||
+			('T' != str[10] && ' ' != str[10]) ||
+			'-' != str[4] || '-' != str[7] || ':' != str[13] || ':' != str[16])
+	{
+		return FAIL;
+	}
+
+	memset(&tm, 0 , sizeof (struct tm));
+	tm.tm_year = atoi(str);
+
+	if (0 == isdigit(str[5]) || 12 < (tm.tm_mon = atoi(&str[5])))
+		return FAIL;
+
+	if (0 == isdigit(str[8]) || 31 < (tm.tm_mday = atoi(&str[8])))
+		return FAIL;
+
+	if (0 == isdigit(str[11]) || 23 < (tm.tm_hour = atoi(&str[11])))
+		return FAIL;
+
+	if (0 == isdigit(str[14]) || 59 < (tm.tm_min = atoi(&str[14])))
+		return FAIL;
+
+	if (0 == isdigit(str[17]) || 59 < (tm.tm_sec = atoi(&str[17])))
+		return FAIL;
+
+	tm.tm_isdst = 0;
+
+#ifdef HAVE_TM_TM_GMTOFF
+	if (FAIL == zbx_iso8601_timezone(&str[19], &tm.tm_gmtoff))
+		return FAIL;
+#endif
+	if (NULL != time)
+	{
+		int	t;
+
+		if(FAIL == zbx_utc_time(tm.tm_year, tm.tm_mon, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec, &t))
+			return FAIL;
+
+		*time = t - tm.tm_gmtoff;
+	}
+
+	return SUCCEED;
+}
diff --git a/src/libs/zbxxml/xml.c b/src/libs/zbxxml/xml.c
index 8230b21acaa..d76ec040d11 100644
--- a/src/libs/zbxxml/xml.c
+++ b/src/libs/zbxxml/xml.c
@@ -1260,6 +1260,24 @@ out:
  *                                                                            *
  ******************************************************************************/
 int	zbx_xml_doc_read_num(xmlDoc *xdoc, const char *xpath, int *num)
+{
+	return zbx_xml_node_read_num(xdoc, NULL, xpath, num);
+}
+
+/******************************************************************************
+ *                                                                            *
+ * Purpose: retrieves numeric xpath value                                     *
+ *                                                                            *
+ * Parameters: xdoc  - [IN] xml document                                      *
+ *             node  - [IN] the XML node                                     *
+ *             xpath - [IN] xpath                                             *
+ *             num   - [OUT] numeric value                                    *
+ *                                                                            *
+ * Return value: SUCCEED - the count was retrieved successfully               *
+ *               FAIL    - otherwise                                          *
+ *                                                                            *
+ ******************************************************************************/
+int	zbx_xml_node_read_num(xmlDoc *xdoc, xmlNode *node, const char *xpath, int *num)
 {
 	int		ret = FAIL;
 	xmlXPathContext	*xpathCtx;
@@ -1267,6 +1285,9 @@ int	zbx_xml_doc_read_num(xmlDoc *xdoc, const char *xpath, int *num)
 
 	xpathCtx = xmlXPathNewContext(xdoc);
 
+	if (NULL != node)
+		xpathCtx->node = node;
+
 	if (NULL == (xpathObj = xmlXPathEvalExpression((const xmlChar *)xpath, xpathCtx)))
 		goto out;
 
diff --git a/src/zabbix_server/poller/checks_simple.c b/src/zabbix_server/poller/checks_simple.c
index bbee69de02a..634e7b4ba3a 100644
--- a/src/zabbix_server/poller/checks_simple.c
+++ b/src/zabbix_server/poller/checks_simple.c
@@ -56,6 +56,7 @@ static zbx_vmcheck_t	vmchecks[] =
 	{"datastore.discovery", VMCHECK_FUNC(check_vcenter_datastore_discovery)},
 	{"datastore.tags.get", VMCHECK_FUNC(check_vcenter_datastore_tags_get)},
 	{"datastore.read", VMCHECK_FUNC(check_vcenter_datastore_read)},
+	{"datastore.perfcounter", VMCHECK_FUNC(check_vcenter_datastore_perfcounter)},
 	{"datastore.property", VMCHECK_FUNC(check_vcenter_datastore_property)},
 	{"datastore.size", VMCHECK_FUNC(check_vcenter_datastore_size)},
 	{"datastore.write", VMCHECK_FUNC(check_vcenter_datastore_write)},
@@ -76,6 +77,7 @@ static zbx_vmcheck_t	vmchecks[] =
 	{"hv.datastore.list", VMCHECK_FUNC(check_vcenter_hv_datastore_list)},
 	{"hv.datastore.multipath", VMCHECK_FUNC(check_vcenter_hv_datastore_multipath)},
 	{"hv.discovery", VMCHECK_FUNC(check_vcenter_hv_discovery)},
+	{"hv.diskinfo.get", VMCHECK_FUNC(check_vcenter_hv_diskinfo_get)},
 	{"hv.fullname", VMCHECK_FUNC(check_vcenter_hv_fullname)},
 	{"hv.hw.cpu.num", VMCHECK_FUNC(check_vcenter_hv_hw_cpu_num)},
 	{"hv.hw.cpu.freq", VMCHECK_FUNC(check_vcenter_hv_hw_cpu_freq)},
diff --git a/src/zabbix_server/poller/checks_simple_vmware.c b/src/zabbix_server/poller/checks_simple_vmware.c
index 4df656395d4..cab488b5e8e 100644
--- a/src/zabbix_server/poller/checks_simple_vmware.c
+++ b/src/zabbix_server/poller/checks_simple_vmware.c
@@ -301,6 +301,18 @@ static int	vmware_service_get_counter_value_by_id(zbx_vmware_service_t *service,
 
 	perfcounter = (zbx_vmware_perf_counter_t *)entity->counters.values[i];
 
+	if (0 != (perfcounter->state & ZBX_VMWARE_COUNTER_NOTSUPPORTED))
+	{
+		SET_MSG_RESULT(result, zbx_strdup(NULL, "Performance counter not supported or data not ready."));
+		goto out;
+	}
+
+	if (0 != (ZBX_VMWARE_COUNTER_CUSTOM & perfcounter->state) &&
+			0 != (ZBX_VMWARE_COUNTER_READY & perfcounter->state))
+	{
+		perfcounter->last_used = time(NULL);
+	}
+
 	if (0 == (perfcounter->state & ZBX_VMWARE_COUNTER_READY))
 	{
 		ret = SYSINFO_RET_OK;
@@ -644,18 +656,20 @@ static int	custquery_read_result(zbx_vmware_cust_query_t *custom_query, AGENT_RE
 	}
 
 	if (0 != (custom_query->state & ZBX_VMWARE_CQ_READY))
+	{
 		SET_STR_RESULT(result, zbx_strdup(NULL, ZBX_NULL2EMPTY_STR(custom_query->value)));
 
-	if (0 != (custom_query->state & ZBX_VMWARE_CQ_PAUSED))
-		custom_query->state &= (unsigned char)~ZBX_VMWARE_CQ_PAUSED;
+		if (0 != (custom_query->state & ZBX_VMWARE_CQ_PAUSED))
+			custom_query->state &= (unsigned char)~ZBX_VMWARE_CQ_PAUSED;
 
-	if (NULL != custom_query->value && '\0' != *custom_query->value &&
-			0 != (custom_query->state & ZBX_VMWARE_CQ_SEPARATE))
-	{
-		custom_query->state &= (unsigned char)~ZBX_VMWARE_CQ_SEPARATE;
-	}
+		if (NULL != custom_query->value && '\0' != *custom_query->value &&
+				0 != (custom_query->state & ZBX_VMWARE_CQ_SEPARATE))
+		{
+			custom_query->state &= (unsigned char)~ZBX_VMWARE_CQ_SEPARATE;
+		}
 
-	custom_query->last_pooled = time(NULL);
+		custom_query->last_pooled = time(NULL);
+	}
 
 	return SYSINFO_RET_OK;
 }
@@ -789,6 +803,12 @@ int	check_vcenter_cluster_discovery(AGENT_REQUEST *request, const char *username
 		zbx_json_close(&json_data);
 		zbx_json_addarray(&json_data, "tags");
 		vmware_tags_id_json(&service->data_tags, ZBX_VMWARE_SOAP_CLUSTER, cluster->id, &json_data, NULL);
+		zbx_json_close(&json_data);
+		zbx_json_addarray(&json_data, "datastore_uuid");
+
+		for (j = 0; j < cluster->dss_uuid.values_num; j++)
+			zbx_json_addstring(&json_data, NULL, cluster->dss_uuid.values[j], ZBX_JSON_TYPE_STRING);
+
 		zbx_json_close(&json_data);
 		zbx_json_close(&json_data);
 	}
@@ -1406,7 +1426,7 @@ int	check_vcenter_hv_discovery(AGENT_REQUEST *request, const char *username, con
 		AGENT_RESULT *result)
 {
 	struct zbx_json		json_data;
-	const char		*url, *name;
+	const char		*url;
 	zbx_vmware_service_t	*service;
 	int			ret = SYSINFO_RET_FAIL;
 	zbx_vmware_hv_t		*hv;
@@ -1433,6 +1453,7 @@ int	check_vcenter_hv_discovery(AGENT_REQUEST *request, const char *username, con
 	while (NULL != (hv = (zbx_vmware_hv_t *)zbx_hashset_iter_next(&iter)))
 	{
 		int			i;
+		const char		*name;
 		zbx_vmware_cluster_t	*cluster = NULL;
 
 		if (NULL == (name = hv->props[ZBX_VMWARE_HVPROP_NAME]))
@@ -1495,6 +1516,98 @@ out:
 	return ret;
 }
 
+int	check_vcenter_hv_diskinfo_get(AGENT_REQUEST *request, const char *username, const char *password,
+		AGENT_RESULT *result)
+{
+	struct zbx_json		json_data;
+	const char		*url, *uuid;
+	zbx_vmware_service_t	*service;
+	int			i, ret = SYSINFO_RET_FAIL;
+	zbx_vmware_hv_t		*hv;
+
+	zabbix_log(LOG_LEVEL_DEBUG, "In %s()", __func__);
+
+	if (2 != request->nparam)
+	{
+		SET_MSG_RESULT(result, zbx_strdup(NULL, "Invalid number of parameters."));
+		goto out;
+	}
+
+	url = get_rparam(request, 0);
+	uuid = get_rparam(request, 1);
+
+	if ('\0' == *uuid)
+	{
+		SET_MSG_RESULT(result, zbx_strdup(NULL, "Invalid second parameter."));
+		goto out;
+	}
+
+	zbx_vmware_lock();
+
+	if (NULL == (service = get_vmware_service(url, username, password, result, &ret)))
+		goto unlock;
+
+	if (NULL == (hv = hv_get(&service->data->hvs, uuid)))
+	{
+		SET_MSG_RESULT(result, zbx_strdup(NULL, "Unknown hypervisor uuid."));
+		goto unlock;
+	}
+
+	zbx_json_initarray(&json_data, ZBX_JSON_STAT_BUF_LEN);
+
+	for (i = 0; i < hv->diskinfo.values_num; i++)
+	{
+		zbx_vmware_diskinfo_t	*di = hv->diskinfo.values[i];
+
+		zbx_json_addobject(&json_data, NULL);
+		zbx_json_addstring(&json_data, "instance", di->diskname,
+				ZBX_JSON_TYPE_STRING);
+		zbx_json_addstring(&json_data, "hv_uuid", hv->uuid, ZBX_JSON_TYPE_STRING);
+		zbx_json_addstring(&json_data, "datastore_uuid", ZBX_NULL2EMPTY_STR(di->ds_uuid),
+				ZBX_JSON_TYPE_STRING);
+		zbx_json_addraw(&json_data, "operational_state", ZBX_NULL2EMPTY_STR(di->operational_state));
+		zbx_json_addstring(&json_data, "lun_type", ZBX_NULL2EMPTY_STR(di->lun_type),
+				ZBX_JSON_TYPE_STRING);
+		zbx_json_addint64(&json_data, "queue_depth", di->queue_depth);
+		zbx_json_addstring(&json_data, "model", ZBX_NULL2EMPTY_STR(di->model),
+				ZBX_JSON_TYPE_STRING);
+		zbx_json_addstring(&json_data, "vendor", ZBX_NULL2EMPTY_STR(di->vendor),
+				ZBX_JSON_TYPE_STRING);
+		zbx_json_addstring(&json_data, "revision", ZBX_NULL2EMPTY_STR(di->revision),
+				ZBX_JSON_TYPE_STRING);
+		zbx_json_addstring(&json_data, "serial_number", ZBX_NULL2EMPTY_STR(di->serial_number),
+				ZBX_JSON_TYPE_STRING);
+		zbx_json_addobject(&json_data, "vsan");
+
+		if (NULL != di->vsan)
+		{
+			zbx_json_addstring(&json_data, "ssd", ZBX_NULL2EMPTY_STR(di->vsan->ssd),
+					ZBX_JSON_TYPE_STRING);
+			zbx_json_addstring(&json_data, "local_disk", ZBX_NULL2EMPTY_STR(di->vsan->local_disk),
+					ZBX_JSON_TYPE_STRING);
+			zbx_json_adduint64(&json_data, "block", di->vsan->block);
+			zbx_json_adduint64(&json_data, "block_size", di->vsan->block_size);
+		}
+
+		zbx_json_close(&json_data);
+		zbx_json_close(&json_data);
+	}
+
+	zbx_json_close(&json_data);
+
+	SET_STR_RESULT(result, zbx_strdup(NULL, json_data.buffer));
+
+	zbx_json_free(&json_data);
+
+	ret = SYSINFO_RET_OK;
+unlock:
+	zbx_vmware_unlock();
+out:
+	zabbix_log(LOG_LEVEL_DEBUG, "End of %s():%s", __func__, zbx_sysinfo_ret_string(ret));
+
+	return ret;
+}
+
 int	check_vcenter_hv_fullname(AGENT_REQUEST *request, const char *username, const char *password,
 		AGENT_RESULT *result)
 {
@@ -2309,17 +2422,41 @@ int	check_vcenter_hv_datastore_discovery(AGENT_REQUEST *request, const char *use
 	for (i = 0; i < hv->dsnames.values_num; i++)
 	{
 		zbx_vmware_dsname_t	*dsname = hv->dsnames.values[i];
+		zbx_vmware_datastore_t	*datastore;
 		int			j, total = 0;
 
+		if (NULL == (datastore = ds_get(&service->data->datastores, dsname->uuid)))
+		{
+			zbx_json_free(&json_data);
+			SET_MSG_RESULT(result, zbx_strdup(NULL, "Unknown datastore uuid."));
+			goto unlock;
+		}
+
 		for (j = 0; j < dsname->hvdisks.values_num; j++)
 			total += dsname->hvdisks.values[j].multipath_total;
 
 		zbx_json_addobject(&json_data, NULL);
 		zbx_json_addstring(&json_data, "{#DATASTORE}", dsname->name, ZBX_JSON_TYPE_STRING);
 		zbx_json_addstring(&json_data, "{#DATASTORE.UUID}", dsname->uuid, ZBX_JSON_TYPE_STRING);
+		zbx_json_addstring(&json_data, "{#DATASTORE.TYPE}", ZBX_NULL2EMPTY_STR(datastore->type),
+				ZBX_JSON_TYPE_STRING);
 		zbx_json_adduint64(&json_data, "{#MULTIPATH.COUNT}", (unsigned int)total);
 		zbx_json_adduint64(&json_data, "{#MULTIPATH.PARTITION.COUNT}",
 				(unsigned int)dsname->hvdisks.values_num);
+		zbx_json_addarray(&json_data, "datastore_extent");
+
+		for (j = 0; j < datastore->diskextents.values_num; j++)
+		{
+			zbx_vmware_diskextent_t	*ext = datastore->diskextents.values[j];
+
+			zbx_json_addobject(&json_data, NULL);
+			zbx_json_adduint64(&json_data, "partitionid", ext->partitionid);
+			zbx_json_addstring(&json_data, "instance", ext->diskname,
+					ZBX_JSON_TYPE_STRING);
+			zbx_json_close(&json_data);
+		}
+
+		zbx_json_close(&json_data);
 		zbx_json_addarray(&json_data, "tags");
 		vmware_tags_uuid_json(&service->data_tags, dsname->uuid, &json_data, NULL);
 		zbx_json_close(&json_data);
@@ -2967,15 +3104,15 @@ int	check_vcenter_cl_perfcounter(AGENT_REQUEST *request, const char *username, c
 	}
 
 	/* FAIL is returned if counter already exists */
-	if (SUCCEED == zbx_vmware_service_add_perf_counter(service, "ClusterComputeResource", cluster->id,
-			counterid, "*"))
+	if (SUCCEED == zbx_vmware_service_add_perf_counter(service, ZBX_VMWARE_SOAP_CLUSTER, cluster->id,
+			counterid, ZBX_VMWARE_PERF_QUERY_ALL))
 	{
 		ret = SYSINFO_RET_OK;
 		goto unlock;
 	}
 
 	/* the performance counter is already being monitored, try to get the results from statistics */
-	ret = vmware_service_get_counter_value_by_id(service, "ClusterComputeResource", cluster->id, counterid,
+	ret = vmware_service_get_counter_value_by_id(service, ZBX_VMWARE_SOAP_CLUSTER, cluster->id, counterid,
 			instance, 1, unit, result);
 unlock:
 	zbx_vmware_unlock();
@@ -3028,14 +3165,15 @@ int	check_vcenter_hv_perfcounter(AGENT_REQUEST *request, const char *username, c
 	}
 
 	/* FAIL is returned if counter already exists */
-	if (SUCCEED == zbx_vmware_service_add_perf_counter(service, "HostSystem", hv->id, counterid, "*"))
+	if (SUCCEED == zbx_vmware_service_add_perf_counter(service, ZBX_VMWARE_SOAP_HV, hv->id, counterid,
+			ZBX_VMWARE_PERF_QUERY_ALL))
 	{
 		ret = SYSINFO_RET_OK;
 		goto unlock;
 	}
 
 	/* the performance counter is already being monitored, try to get the results from statistics */
-	ret = vmware_service_get_counter_value_by_id(service, "HostSystem", hv->id, counterid, instance, 1, unit,
+	ret = vmware_service_get_counter_value_by_id(service, ZBX_VMWARE_SOAP_HV, hv->id, counterid, instance, 1, unit,
 			result);
 unlock:
 	zbx_vmware_unlock();
@@ -3276,6 +3414,67 @@ out:
 	return ret;
 }
 
+int	check_vcenter_datastore_perfcounter(AGENT_REQUEST *request, const char *username, const char *password,
+		AGENT_RESULT *result)
+{
+	const char		*instance, *url, *uuid, *path;
+	zbx_vmware_service_t	*service;
+	zbx_vmware_datastore_t	*ds;
+	zbx_uint64_t		counterid;
+	int			unit, ret = SYSINFO_RET_FAIL;
+
+	zabbix_log(LOG_LEVEL_DEBUG, "In %s()", __func__);
+
+	if (3 > request->nparam || request->nparam > 4)
+	{
+		SET_MSG_RESULT(result, zbx_strdup(NULL, "Invalid number of parameters."));
+		goto out;
+	}
+
+	url = get_rparam(request, 0);
+	uuid = get_rparam(request, 1);
+	path = get_rparam(request, 2);
+	instance = get_rparam(request, 3);
+
+	if (NULL == instance)
+		instance = "";
+
+	zbx_vmware_lock();
+
+	if (NULL == (service = get_vmware_service(url, username, password, result, &ret)))
+		goto unlock;
+
+	if (NULL == (ds = ds_get(&service->data->datastores, uuid)))
+	{
+		SET_MSG_RESULT(result, zbx_strdup(NULL, "Unknown datastore uuid."));
+		goto unlock;
+	}
+
+	if (FAIL == zbx_vmware_service_get_counterid(service, path, &counterid, &unit))
+	{
+		SET_MSG_RESULT(result, zbx_strdup(NULL, "Performance counter is not available."));
+		goto unlock;
+	}
+
+	/* FAIL is returned if counter already exists */
+	if (SUCCEED == zbx_vmware_service_add_perf_counter(service, ZBX_VMWARE_SOAP_DS, ds->id, counterid,
+			ZBX_VMWARE_PERF_QUERY_ALL))
+	{
+		ret = SYSINFO_RET_OK;
+		goto unlock;
+	}
+
+	/* the performance counter is already being monitored, try to get the results from statistics */
+	ret = vmware_service_get_counter_value_by_id(service, ZBX_VMWARE_SOAP_DS, ds->id, counterid, instance, 1, unit,
+			result);
+unlock:
+	zbx_vmware_unlock();
+out:
+	zabbix_log(LOG_LEVEL_DEBUG, "End of %s():%s", __func__, zbx_sysinfo_ret_string(ret));
+
+	return ret;
+}
+
 int	check_vcenter_datastore_property(AGENT_REQUEST *request, const char *username, const char *password,
 		AGENT_RESULT *result)
 {
@@ -3407,18 +3606,23 @@ int	check_vcenter_datastore_discovery(AGENT_REQUEST *request, const char *userna
 	for (i = 0; i < service->data->datastores.values_num; i++)
 	{
 		zbx_vmware_datastore_t	*datastore = service->data->datastores.values[i];
+
 		zbx_json_addobject(&json_data, NULL);
 		zbx_json_addstring(&json_data, "{#DATASTORE}", datastore->name, ZBX_JSON_TYPE_STRING);
 		zbx_json_addstring(&json_data, "{#DATASTORE.UUID}", datastore->uuid, ZBX_JSON_TYPE_STRING);
-		zbx_json_addobject(&json_data, "{#DATASTORE.EXTENT}");
+		zbx_json_addstring(&json_data, "{#DATASTORE.TYPE}", ZBX_NULL2EMPTY_STR(datastore->type),
+				ZBX_JSON_TYPE_STRING);
+		zbx_json_addarray(&json_data, "datastore_extent");
 
 		for (j = 0; j < datastore->diskextents.values_num; j++)
 		{
-			char			buffer[MAX_ID_LEN];
-			zbx_vmware_diskextent_t	*extent = datastore->diskextents.values[j];
+			zbx_vmware_diskextent_t	*ext = datastore->diskextents.values[j];
 
-			zbx_snprintf(buffer, sizeof(buffer), ZBX_FS_UI64, extent->partitionid);
-			zbx_json_addstring(&json_data, extent->diskname, buffer, ZBX_JSON_TYPE_INT);
+			zbx_json_addobject(&json_data, NULL);
+			zbx_json_adduint64(&json_data, "partitionid", ext->partitionid);
+			zbx_json_addstring(&json_data, "instance", ext->diskname,
+					ZBX_JSON_TYPE_STRING);
+			zbx_json_close(&json_data);
 		}
 
 		zbx_json_close(&json_data);
@@ -4106,7 +4310,7 @@ int	check_vcenter_vm_discovery(AGENT_REQUEST *request, const char *username, con
 			else
 				zbx_json_addstring(&json_data, "{#VM.RPOOL.PATH}", "", ZBX_JSON_TYPE_STRING);
 
-			zbx_json_addarray(&json_data, "vm.customattribute");
+			zbx_json_addarray(&json_data, "vm_customattribute");
 
 			for (j = 0; j < vm->custom_attrs.values_num; j++)
 			{
@@ -5019,14 +5223,15 @@ int	check_vcenter_vm_perfcounter(AGENT_REQUEST *request, const char *username, c
 	}
 
 	/* FAIL is returned if counter already exists */
-	if (SUCCEED == zbx_vmware_service_add_perf_counter(service, "VirtualMachine", vm->id, counterid, "*"))
+	if (SUCCEED == zbx_vmware_service_add_perf_counter(service, ZBX_VMWARE_SOAP_VM, vm->id, counterid,
+			ZBX_VMWARE_PERF_QUERY_ALL))
 	{
 		ret = SYSINFO_RET_OK;
 		goto unlock;
 	}
 
 	/* the performance counter is already being monitored, try to get the results from statistics */
-	ret = vmware_service_get_counter_value_by_id(service, "VirtualMachine", vm->id, counterid, instance, 1, unit,
+	ret = vmware_service_get_counter_value_by_id(service, ZBX_VMWARE_SOAP_VM, vm->id, counterid, instance, 1, unit,
 			result);
 unlock:
 	zbx_vmware_unlock();
@@ -5618,7 +5823,8 @@ static int	check_vcenter_rp_common(const char *url, const char *username, const
 	}
 
 	/* FAIL is returned if counter already exists */
-	if (SUCCEED == zbx_vmware_service_add_perf_counter(service, ZBX_VMWARE_SOAP_RESOURCEPOOL, rpid, counterid, ""))
+	if (SUCCEED == zbx_vmware_service_add_perf_counter(service, ZBX_VMWARE_SOAP_RESOURCEPOOL, rpid, counterid,
+			ZBX_VMWARE_PERF_QUERY_TOTAL))
 	{
 		ret = SYSINFO_RET_OK;
 		goto unlock;
@@ -5888,4 +6094,20 @@ int	check_vcenter_alarms_get(AGENT_REQUEST *request, const char *username, const
 #undef	ALARMS_GET_START
 #undef	ALARMS_GET_END
 
+#undef	ZBX_VMWARE_DATASTORE_SIZE_TOTAL
+#undef	ZBX_VMWARE_DATASTORE_SIZE_FREE
+#undef	ZBX_VMWARE_DATASTORE_SIZE_PFREE
+#undef	ZBX_VMWARE_DATASTORE_SIZE_UNCOMMITTED
+
+#undef	ZBX_DATASTORE_TOTAL
+#undef	ZBX_DATASTORE_COUNTER_CAPACITY
+#undef	ZBX_DATASTORE_COUNTER_USED
+#undef	ZBX_DATASTORE_COUNTER_PROVISIONED
+
+#undef	ZBX_DATASTORE_DIRECTION_READ
+#undef	ZBX_DATASTORE_DIRECTION_WRITE
+
+#undef	ZBX_IF_DIRECTION_IN
+#undef	ZBX_IF_DIRECTION_OUT
+
 #endif	/* defined(HAVE_LIBXML2) && defined(HAVE_LIBCURL) */
diff --git a/src/zabbix_server/poller/checks_simple_vmware.h b/src/zabbix_server/poller/checks_simple_vmware.h
index a9ba97c9f07..dcb55362960 100644
--- a/src/zabbix_server/poller/checks_simple_vmware.h
+++ b/src/zabbix_server/poller/checks_simple_vmware.h
@@ -52,6 +52,8 @@ int	check_vcenter_datastore_tags_get(AGENT_REQUEST *request, const char *usernam
 		AGENT_RESULT *result);
 int	check_vcenter_datastore_read(AGENT_REQUEST *request, const char *username, const char *password,
 		AGENT_RESULT *result);
+int	check_vcenter_datastore_perfcounter(AGENT_REQUEST *request, const char *username, const char *password,
+		AGENT_RESULT *result);
 int	check_vcenter_datastore_property(AGENT_REQUEST *request, const char *username, const char *password,
 		AGENT_RESULT *result);
 int	check_vcenter_datastore_size(AGENT_REQUEST *request, const char *username, const char *password,
@@ -100,6 +102,8 @@ int	check_vcenter_hv_datastore_multipath(AGENT_REQUEST *request, const char *use
 		AGENT_RESULT *result);
 int	check_vcenter_hv_discovery(AGENT_REQUEST *request, const char *username, const char *password,
 		AGENT_RESULT *result);
+int	check_vcenter_hv_diskinfo_get(AGENT_REQUEST *request, const char *username, const char *password,
+		AGENT_RESULT *result);
 int	check_vcenter_hv_fullname(AGENT_REQUEST *request, const char *username, const char *password,
 		AGENT_RESULT *result);
 int	check_vcenter_hv_hw_cpu_num(AGENT_REQUEST *request, const char *username, const char *password,
